<?php
// printf ('g=' . $g . ' n=' . $n . ' e=' . $e);

// This formats a specific image/element to be displayed on the screen in HTML.
//
// usage: ?g=July%202006&n=PICT0002&e=jpg

if ($g == '' || $n == '' || $e == '') {
  $img_filename = '';
} else {
  $img_filename = $g . "/" . $n . "." . $e;

// Display a link to the original version of the image?
  $img_filename_orig = '';
  //if (file_exists($media_dir . $g . "/" . $n . "_orig." . $e)) {
    // check to see if an _orig file exists, if so, then set the 
    // $img_filename_orig variable, so that it can be detected
    // further in the code
  //  $img_filename_orig = $g . "/" . $n . "_orig." . $e;
  //  printf ($media_dir . $img_filename_orig);
  //}
}

// Determine file type from $e
switch (strtolower($e)) {
  case "jpg":
    $filetype = 'jpg';
    break;
  case "jpeg":
    $filetype = 'jpg';
    break;
  case "flv":
    $filetype = 'flv';
    break;
  case "tiff":
    $filetype = 'tif';
    break;
  case "tif":
    $filetype = 'tif';
    break;
  case "gif":
    $filetype = 'gif';
    break;
  default:
    $filetype = 'generic';
}

if ($img_filename != '') {
  // Get intrinsic data and EXIF data of current image (if JPEG)
  if (file_exists($media_dir . $img_filename) && $filetype == "jpg") {
    $jpeg_header_data = get_jpeg_header_data($media_dir . $img_filename);
    $jpeg_intrinsic = get_jpeg_intrinsic_values($jpeg_header_data);
    
    // Get Camera related information
    $jpeg_exif = get_EXIF_JPEG($media_dir . $img_filename);
    
    // Get Photoshop related information
    $jpeg_photoshop = get_Photoshop_IRB($jpeg_header_data);   // all the data
    $jpeg_iptc = get_Photoshop_IPTC($jpeg_photoshop);         // parse IPTC
  }
  // TODO: get information for other file types
  //
  //
  //
  //
  if (file_exists($media_dir . $img_filename) && $filetype == "gif") {
    // Not implemented
    // printf ("GIF file description support not yet implemented<br>\n");
    printf ("");
  }
  //
  //
  //
  //
  //
}

function printNav() {
  global $ftotal, $i, $g;
  if ($ftotal) {
    if ($i > 9) {
      printf ("<span class=\"navsmallstrong\">\n");
      printf ("<a href=\"");
      printf ("?m=s&g=" . $g . "&i=");
      printf ($i - 10);
      printf ("\">&laquo; Skip 10</a>\n");
      printf ("</span><span class=\"nav\"> | </span>\n"); 
    }
  }
// check to see, if there are photos to scroll back,
// if there is, then display a link
  if ($ftotal) {
    if ($i > 0) {
      printf ("<span class=\"navstrong\">\n");
      printf ("<a href=\"");
      printf ("?m=s&g=" . $g .  "&i=");
      printf ($i - 1);
      printf ("\">&laquo; Prev</a>\n");
      printf ("</span><span class=\"nav\"> | </span>\n");
    }
  }

  // 1 of 29...
  if ($ftotal) {
    printf ("<span class=\"nav\">\n");
    printf($i + 1);
    printf(' of ');
    printf($ftotal);
    printf("</span>");
  }
  
  // check to see if NEXT button should be available
  if ($ftotal) {
    if (($i + 1) < $ftotal) {
      printf("<span class=\"nav\"> | </span>\n"); 
      printf("<span class=\"navstrong\">\n");
      printf("<a href=\"");
      printf("?m=s&g=" . $g . "&i=");
      printf($i + 1);
      printf("\">Next &raquo;</a>\n");
      // now check if there's over 10 more to go.
      if (($i + 10) < $ftotal) {
        printf("</span><span class=\"nav\"> | </span>\n");
        printf("<span class=\"navsmallstrong\">\n");
        printf("<a href=\"");
        printf("?m=s&g=" . $g . "&i=");
        printf($i + 10);
        printf("\">Skip 10 &raquo;</a>\n");
        printf("</span>\n");
      }
    }
  }
}      


// Prints information about a file in the information box. Made to simplify html-writing.
function printinfo($info_name, $info_value, $linktype) {
  global $media_info_link;
  printf("<span class=\"photoinfoname\">" . $info_name);
  if  ($info_name) {
    printf(": ");
  }
  printf("</span><span class=\"photoinfodata\">");
  if ($linktype != "" && $media_info_link) {
    printf("<a href=\"http://www.google.fi/search?q=" . $info_value);
    if ($linktype === 'direct') {
      printf("&btnI"); 
    }
    printf("\" target=\"_blank\">" . $info_value);
    printf("</a>");
  } else {
    printf($info_value);
  }
  printf("</span>\n");
}

?>

<table border="0" align="center" cellpadding="2" cellspacing="1">
  <tr>
    <td align="center" nowrap>
      <?php 
        printNav();
      ?>
    </td>
  </tr>
  <tr>
    <td align="center">
      <table border="0" align="center" cellpadding="4" cellspacing="1" bgcolor="#D0D0D0">
        <tr>
          <td bgcolor="#FFFFFF">
            <?php
              if ($img_filename != '') {
                if (file_exists($media_dir . $img_filename)) {
                  // File exists. Check to see how the file will be displayed:
                  // TODO: Automatic enumerating of plugins and displaying them
                  // according to how they have to be viewed.
                  switch ($filetype) {
                  case "flv":
                    // Using the excellent flash video player by Jeroen Wijering (http://www.jeroenwijering.com)
                    include_once("./plugins/flv/flv.php");
                  default:
                    printf("<img src=\"" . $media_dir . $img_filename . "\" alt=\"" . $img_description . "\">");
                    // printf("Display support not yet implemented.\n");
                  }
                } else {
                // Image isn't available
                printf("<strong>Error: file <em>" . $media_dir . $img_filename . "</em> doesn't exist.</strong>");
                } 
              } else {
                printf("<strong>Error: no filename specified.</strong>");
              }
            ?>
          </td>
        </tr>
      </table>
    </td>
  </tr>
  <tr>
    <td align="center" nowrap>
      <?php 
        printNav();
      ?>
    </td>
  </tr>
  <tr>
    <td align="center" class="photodescription">
      <?php
        // Display Description in EXIF/IPTC tag
        if ($jpeg_exif[0][270]['Tag Name'] and $media_info_exif_description) {
          // exif description...
          printf($jpeg_exif[0][270]['Text Value']);
          printf("<br>\n");
        } 
        if ($jpeg_iptc[1]['RecData'] and $media_info_iptc_description) {
          // photoshop description...
          printf($jpeg_iptc[1]['RecData']);
          printf("<br>\n");
        }
      ?>
    </td>
  </tr>
  <tr>
    <td>
      <div align="center">
        <strong>
          <?php 
            if ($img_description != '') {
              printf($img_description);
            }
          ?>
        </strong>
      </div>   
    </td>
  </tr>
  <tr>
    <td>
      <table border="0" align="center" cellpadding="4" cellspacing="1" bgcolor="#D0D0D0">
        <tr>
          <td valign="top" nowrap bgcolor="#FFFFFF">
            <?php 
              printf("<div align=\"center\">");
              printf("<span class=\"photoinfoname\"><strong>Photo Information</strong></span><br>");
              printf("</div>");
              // Print Copyright Information
              if ($jpeg_exif[0][33432]['Tag Value']) {
                // in exif tag:
                printinfo($jpeg_exif[0][33432]['Tag Name'], $jpeg_exif[0][33432]['Text Value'], false);
                printf("<br>\n");
              } else if ($jpeg_iptc[2]['RecData']) {
                // if not in exif -tag, check the Photoshop record (IPTC in IRB)
                printinfo($jpeg_iptc[2]['RecName'], $jpeg_iptc[2]['RecData'], false);
                printf("<br>\n");
              }
              // Print file name
              if ($media_info_filename == true) {
                printinfo('Filename', basename($img_filename), false);
                printf("<br>\n");
              }
              // Print manufacturer information
              if ($jpeg_exif[0][271]['Tag Name']) {
                printinfo($jpeg_exif[0][271]['Tag Name'], $jpeg_exif[0][271]['Text Value'], 'direct');
                // Print the camera model information
                printinfo('', $jpeg_exif[0][272]['Text Value'], true);
                printf("<br>\n");
              }
              // Print the date and time
              if ($jpeg_exif[0][306]['Data'][0]) {
                printinfo('Date', str_replace(":", "/", substr($jpeg_exif[0][306]['Data'][0], 0, 10)), false);
                printinfo('Time', ' ' . substr($jpeg_exif[0][306]['Data'][0], 11, 5), false);
                printf("<br>\n");
              } else {
                // No EXIF information for DATE/TIME, use the date from the last modified date.
                printinfo('Last Modified', date("Y/m/d", filemtime($media_dir . $img_filename)), false);
              }
            ?>
          </td>
            <?php
              // Contains EXIF -information?
              if ( $jpeg_exif[ 'Tags Name' ] == "TIFF" ) {
                printf ("<td valign=\"top\" nowrap bgcolor=\"#FFFFFF\">");
                printf("<div align=\"center\">");
                printf("<span class=\"photoinfoname\"><strong>Camera Settings</strong></span><br>");
                printf("</div>");
                // Print ISO Speed Rating
                if ($jpeg_exif[0][34665]['Data'][0][34855]['Tag Name']) {
                  printinfo('ISO Speed Rating', $jpeg_exif[0][34665]['Data'][0][34855]['Text Value'], false);
                  printf("<br>\n");
                }
                // Print Exposure Settings
                if ($jpeg_exif[0][34665]['Data'][0][33434]['Tag Name']) {
                  printinfo($jpeg_exif[0][34665]['Data'][0][33434]['Tag Name'], $jpeg_exif[0][34665]['Data'][0][33434]['Text Value'], false);
                  printf("<br>\n");
                }
                // Print Apex Exposure Settings
                if ($jpeg_exif[0][34665]['Data'][0][37377]['Tag Name']) {
                  printinfo($jpeg_exif[0][34665]['Data'][0][37377]['Tag Name'], $jpeg_exif[0][34665]['Data'][0][37377]['Text Value'], false);
                  printf("<br>\n");
                }
                // Print Exposure Compensation
                if ($jpeg_exif[0][34665]['Data'][0][37380]['Tag Name']) {
                  printinfo('Exposure Compensation', $jpeg_exif[0][34665]['Data'][0][37380]['Text Value'], false);
                  printf("<br>\n");
                }
                // Print Aperture Settings
                if ($jpeg_exif[0][34665]['Data'][0][33437]['Tag Name']) {
                  printinfo('Aperture', $jpeg_exif[0][34665]['Data'][0][33437]['Text Value'], false);
                  printf("<br>\n");
                }
                // // Print Scene Type
                // printinfo($jpeg_exif[0][34665]['Data'][0][41729]['Tag Name'], $jpeg_exif[0][34665]['Data'][0][41729]['Text Value'], false);
                // printf("<br>\n");
                // // Print Image Size in pixels
                // printinfo('Size', $jpeg_intrinsic['Image Width'] . "x" . $jpeg_intrinsic['Image Height'], false);
                // printf("<br>\n");
                printf ("</td>\n");
              } else {
                // no EXIF available
                printf ("<!-- No EXIF information available -->\n");
              }
            ?>
        </tr>
      </table>
    </td>
  </tr>
</table>