<?php
  /* show.php                       */
  /* Format a page to show requested information */
  
  // Check if gallery exists
  if (!file_exists($media_dir . $g)) {
    printf("<strong>Error: media path <em>" . $media_dir . $g . "</em> doesn't exist. The requested gallery name may be wront, or a variable in settings.php isn't set properly. Please check settings.php to see that \$media_dir is correct.</strong>");
    exit();
  }
  function listfiles($dirname=".") {
    global $media_supported;
    $ext = $media_supported;
    $files = array();
    if($handle = opendir($dirname)) {
      while(false !== ($file = readdir($handle)))
        for($i=0;$i<sizeof($ext);$i++)
          if(strstr(strtolower($file), ".".$ext[$i]))
            $files[] = $file;
       closedir($handle);
     }
     return($files);
  }
  $flist = listfiles($media_dir . $g . "/");
  $ftotal = count($flist);

  // To display images in order, sort the array
  natcasesort($flist);
  $flist = array_values($flist);    // change array numbering here as well

  // If opening the page for the first time, define the first image to be shown
  if (!$i) {
    $i = '0';
  }
  // Define missing names and extensions for element.php...
  $finfo = pathinfo($media_dir . $g . "/" . $flist[$i]);
  $n = basename($finfo['basename'], '.' . $finfo['extension']);
  $e = $finfo['extension'];
?>

<html>
  <head>
    <title><?php printf($page_title) ?></title>
    <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
    <link rel="stylesheet" type="text/css" href="style.css">
  </head>
  <body>
  <!-- Header Image, if defined -->
    <?php 
      // First check the header image is available
      if ($page_headerimage != '') {
        if (file_exists($page_headerimage)) {
          if ($page_headerimagealt == '') {
            $page_headerimagealt = $page_headerimage;
          }
          printf ("<div align=\"center\">");
          printf ("<img src=\"" . $page_headerimage . "\" alt=\"" . $page_headerimagealt . "\">");
          printf ("</div>\n");
          printf ("<br>\n");
        } else {
          // Header image isn't available
          printf("<strong>Error in Gallery Settings: Header Image file <em>" . $page_headerimage . "</em> doesn't exist.</strong>");
        }
      } 
    ?>
    <!-- Header Text, if defined -->
    <?php
      if ($page_headertext != '') {
        printf("<div class=\"heading\">");
        printf($page_headertext);
        printf("</div>");
//        printf("<br>\n");
      }
      if ($page_gallerytext and $g) {
        printf("<div class=\"heading\">");
        printf($g);
        printf("</div>");
//        printf("<br>\n");
      }
    ?>
    <!-- Media file to be displayed -->
    <?php
      include_once("element.php");
      
      // Display Copyright tags.
      if ($page_copyright) {
        printf ("<br>");
        printf ("<div align=\"center\">");
        printf ($page_copyright);
        printf ("</div>");
      }
    ?>
  </body>
</html>


